﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Web.Http
Imports System.Web.Http.OData.Builder
Imports System.Web.Http.OData.Extensions

Public Module WebApiConfig
    Public Sub Register(ByVal config As HttpConfiguration)
        ' Web API configuration and services
        config.AddODataQueryFilter()

        Dim builder As New ODataConventionModelBuilder()
        builder.EntitySet(Of Customer)("odatacustomers")
        config.Routes.MapODataServiceRoute("odata", "odata", builder.GetEdmModel())

        ' Web API routes
        config.MapHttpAttributeRoutes()

        config.Routes.MapHttpRoute(
            name:="DefaultApi",
            routeTemplate:="api/{controller}/{id}",
            defaults:=New With {.id = RouteParameter.Optional}
            )
    End Sub
End Module
